    001    /* ===========================================================
    002     * JFreeChart : a free chart library for the Java(tm) platform
    003     * ===========================================================
    004     *
    005     * (C) Copyright 2000-2007, by Object Refinery Limited and Contributors.
    006     *
    007     * Project Info:  http://www.jfree.org/jfreechart/index.html
    008     *
    009     * This library is free software; you can redistribute it and/or modify it
    010     * under the terms of the GNU Lesser General Public License as published by
    011     * the Free Software Foundation; either version 2.1 of the License, or
    012     * (at your option) any later version.
    013     *
    014     * This library is distributed in the hope that it will be useful, but
    015     * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
    016     * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public
    017     * License for more details.
    018     *
    019     * You should have received a copy of the GNU Lesser General Public
    020     * License along with this library; if not, write to the Free Software
    021     * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301,
    022     * USA.
    023     *
    024     * [Java is a trademark or registered trademark of Sun Microsystems, Inc.
    025     * in the United States and other countries.]
    026     *
    027     * ------------------------
    028     * AreaRendererEndType.java
    029     * ------------------------
    030     * (C) Copyright 2004-2007, by Object Refinery Limited.
    031     *
    032     * Original Author:  David Gilbert (for Object Refinery Limited);
    033     * Contributor(s):   -;
    034     *
    035     * Changes:
    036     * --------
    037     * 29-April-2004 : Version 1 (DG);
    038     *
    039     */
    040
    041    package org.jfree.chart.renderer;
    042
    043    import java.io.ObjectStreamException;
    044    import java.io.Serializable;
    045
    046    /**
    047     * An enumeration of the 'end types' for an area renderer.
    048     */
    049    public final class AreaRendererEndType implements Serializable {
    050
    051        /** For serialization. */
    052        private static final long serialVersionUID = -1774146392916359839L;
    053
    054        /**
    055         * The area tapers from the first or last value down to zero.
    056         */
    057        public static final AreaRendererEndType TAPER = new AreaRendererEndType(
    058            "AreaRendererEndType.TAPER"
    059        );
    060
    061        /**
    062         * The area is truncated at the first or last value.
    063         */
    064        public static final AreaRendererEndType TRUNCATE = new AreaRendererEndType(
    065            "AreaRendererEndType.TRUNCATE"
    066        );
    067
    068        /**
    069         * The area is levelled at the first or last value.
    070         */
    071        public static final AreaRendererEndType LEVEL = new AreaRendererEndType(
    072            "AreaRendererEndType.LEVEL"
    073        );
    074
    075        /** The name. */
    076        private String name;
    077
    078        /**
    079         * Private constructor.
    080         *
    081         * @param name  the name.
    082         */
    083        private AreaRendererEndType(String name) {
    084            this.name = name;
    085        }
    086
    087        /**
    088         * Returns a string representing the object.
    089         *
    090         * @return The string.
    091         */
    092        public String toString() {
    093            return this.name;
    094        }
    095
    096        /**
    097         * Returns <code>true</code> if this object is equal to the specified
    098         * object, and <code>false</code> otherwise.
    099         *
    100         * @param o  the other object.
    101         *
    102         * @return A boolean.
    103         */
    104        public boolean equals(Object o) {
    105
    106            if (this == o) {
    107                return true;
    108            }
    109            if (!(o instanceof AreaRendererEndType)) {
    110                return false;
    111            }
    112
    113            AreaRendererEndType t = (AreaRendererEndType) o;
    114            if (!this.name.equals(t.toString())) {
    115                return false;
    116            }
    117
    118            return true;
    119
    120        }
    121
    122        /**
    123         * Ensures that serialization returns the unique instances.
    124         *
    125         * @return The object.
    126         *
    127         * @throws ObjectStreamException if there is a problem.
    128         */
    129        private Object readResolve() throws ObjectStreamException {
    130            Object result = null;
    131            if (this.equals(AreaRendererEndType.LEVEL)) {
    132                result = AreaRendererEndType.LEVEL;
    133            }
    134            else if (this.equals(AreaRendererEndType.TAPER)) {
    135                result = AreaRendererEndType.TAPER;
    136            }
    137            else if (this.equals(AreaRendererEndType.TRUNCATE)) {
    138                result = AreaRendererEndType.TRUNCATE;
    139            }
    140            return result;
    141        }
    142
    143    }